config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  #
  #
  resources :rooms do
    resources :bookings
  end
  root 'rooms#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/booking.rb
class Booking < ApplicationRecord
  belongs_to :room
  validates :username, presence: true
  validates :startdate, presence: true
  validates :enddate, presence: true
end

app/models/room.rb
class Room < ApplicationRecord
  has_many :bookings, dependent: :destroy
  validates :name, presence: true, length: { minimum: 5 }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController

  def create
    @room = Room.find(params[:room_id])
    @bookings = @room.bookings.new(booking_params)

    unless is_input_invalid?
      swapDate
    end

    if is_date_free?
      if @bookings.save
        redirect_to room_path(@room)
      else
        @error_msg = "Couldn't save booking."
        render 'rooms/show'
      end
    else
      @error_msg = "Couldn't save booking. The chosen dates have been already booked."
      render 'rooms/show'
    end
  end

  def index
    @room = Room.find(params[:room_id])
    redirect_to room_path(@room)
  end

  def destroy
    @room = Room.find(params[:room_id])
    @booking = @room.bookings.find(params[:id])
    @booking.destroy
    redirect_to room_path(@room)
  end

  private
  def booking_params
    params.require(:booking).permit(:username, :startdate, :enddate)
  end

  def swapDate
    if @bookings.startdate > @bookings.enddate
      @tmp = @bookings.startdate
      @bookings.startdate = @bookings.enddate
      @bookings.enddate = @tmp
    end
  end

  def is_input_invalid?
    @bookings.username.empty? || @bookings.startdate.nil? || @bookings.enddate.nil?
  end

  def is_date_free?
    is_free = true
    @date_between = @room.bookings.where('? >= startdate AND ? <= enddate', @bookings.startdate, @bookings.enddate).count
    @date_partially_contains = @room.bookings.where('? <= enddate AND ? >= enddate', @bookings.startdate, @bookings.enddate).count
    @date_longer = @room.bookings.where('? <= startdate AND ? >= enddate', @bookings.startdate, @bookings.enddate).count

    if (@date_between + @date_longer + @date_partially_contains) > 0
      is_free = false
    end

    is_free
  end

end

app/controllers/rooms_controller.rb
class RoomsController < ApplicationController
  def index
    @rooms = Room.all
  end

  def create
    @room = Room.new(room_params)
    if @room.save
      redirect_to @room
    else
      render 'rooms/new'
    end
  end

  def update
    @room = Room.find(params[:id])
    if @room.update(room_params)
      redirect_to rooms_path
    else
      render 'rooms/edit'
    end
  end

  def destroy
    @room = Room.find(params[:id])
    @room.destroy
    redirect_to rooms_path
  end

  def show
    @room = Room.find(params[:id])
  end

  def edit
    @room = Room.find(params[:id])
  end

  private
  def room_params
    params.require(:room).permit(:name, :roomtype)
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/helpers/players_helper.rb
module PlayersHelper
end

app/helpers/rooms_helper.rb
module RoomsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Theassociation</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/rooms/edit.html.erb
<h1>Edit article</h1>

<%= form_with(model: @room, local: true) do |form| %>

  <% if @room != nil && @room.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@room.errors.count, "error") %> prohibited
        this article from being saved:
      </h2>
      <ul>
        <% @room.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <p>
    <%= form.label :name %><br>
    <%= form.text_field :name %>
  </p>

  <p>
    <%= form.label :roomtype %><br>
    <%= form.select :roomtype, ['Targyalo','Kivetito'], :prompt => 'Select One' %>
  </p>

  <p>
    <%= form.submit %>
  </p>

<% end %>

<%= link_to 'Back', rooms_path %>

app/views/rooms/index.html.erb
<table>
  <tr>
    <th>Room name</th>
    <th>Room type</th>
    <th colspan="2"></th>
  </tr>


  <% @rooms.each do |room| %>
    <tr>
      <td><%= room.name %></td>
      <td><%= room.roomtype %></td>
      <td><%= link_to 'Show', room_path(room) %></td>
      <td><%= link_to 'Edit', edit_room_path(room) %></td>
      <td><%= link_to 'Delete', room_path(room), method: :delete %></td>
    </tr>
  <% end %>
</table>
<br>

<%= link_to 'New', new_room_path %>

app/views/rooms/new.html.erb
<%= form_with scope: :room, url: rooms_path, local: true do |form| %>

  <% if @room != nil &&  @room.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@room.errors.count, "error") %> prohibited this article from being saved:
      </h2>
      <ul>
        <% @room.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <p>
    <%= form.label :name %><br>
    <%= form.text_field :name %>
  </p>

  <p>
    <%= form.label :roomtype %><br>
    <%= form.select :roomtype, ['Targyalo','Kivetito']%>
  </p>

  <p>
    <%= form.submit %>
  </p>

<% end %>

<%= link_to 'Back', rooms_path %>

app/views/rooms/show.html.erb
<p>
  <strong>Room name:</strong>
  <%= @room.name %>
</p>

<p>
  <strong>Room type:</strong>
  <%= @room.roomtype %>
</p>

<h2 style="color: firebrick"> <%= @error_msg %> </h2>
<h2 style="color: green"> <%= @msg %> </h2>

<h3>Previous bookings</h3>
<table>
  <tr>
    <td style="border: 1px solid black">Username</td>
    <td style="border: 1px solid black">Starting date</td>
    <td style="border: 1px solid black">Ending date</td>
  </tr>

  <% @room.bookings.each do |booking| %>
    <% if Booking.find_by_id(booking.id) %>
  <tr>
    <td style="border: 1px solid black"><%= booking.username %></td>
    <td style="border: 1px solid black"><%= booking.startdate %></td>
    <td style="border: 1px solid black"><%= booking.enddate %></td>
    <td ><%= link_to 'Delete', [booking.room, booking], method: :delete %></td>
  </tr>
    <% end %>
  <% end %>
</table>

<h2>Book the room:</h2>
<%= form_with(model: [ @room, @room.bookings.build ], local: true) do |form| %>
  <p>
    <%= form.label :username %><br>
    <%= form.text_field :username %>
  </p>
  <p>
    <%= form.label :startdate %><br>
    <%= date_field("booking", "startdate") %>
  </p>
  <p>
    <%= form.label :enddate %><br>
    <%= date_field("booking", "enddate") %>
  </p>
  <p>
    <%= form.submit %>
  </p>
<% end %>


<%= link_to 'All rooms', rooms_path %>